
/*

	[Jit.findbounds] way (a little bit complex, isn't it ?).
	It should be possible to do the same just with max objects.
	Thanks for comments & feedback ;)
	
*/


// -------------------------------------------------------------------------------------

inlets = 1 ;
outlets = 1 ;

setinletassist (0, "nimportkwa") ;
setoutletassist (0, "pwindow") ;

autowatch = 1 ;

// -------------------------------------------------------------------------------------

var POS_X = 20,
	POS_Y = 60 ;  // text position in pixels.

// -------------------------------------------------------------------------------------

var myrender = new JitterObject ("jit.gl.render", "toto") ;
    myrender.erase_color = [0., 0., 0., 1.] ;
    myrender.blend_enable = 1 ;
	
var mytext = new JitterObject ("jit.gl.text2d", "toto") ;
    mytext.blend_enable = 1 ;
	mytext.depth_enable = 0 ;
    mytext.color = [1., 1., 1., 1.] ; 
    mytext.position = [0., 0., 0.] ;
    mytext.align = 0 ;
    mytext.font ("Arial") ;
	mytext.face ("bold") ;
    mytext.size (24) ;

var mytextbis = new JitterObject ("jit.gl.text2d", "toto") ;
    mytextbis.blend_enable = 1 ;
	mytextbis.depth_enable = 0 ;
    mytextbis.color = [1., 1., 0., 1.] ;
    mytextbis.position = [0., 0., 0.] ;
    mytextbis.align = 0 ;
    mytextbis.font ("Times Roman") ;
	mytextbis.face ("italic") ;
    mytextbis.size (20) ;
	
var mymatrix = new JitterObject ("jit.matrix", "toto") ;         // rendering across a jit.matrix.
	mymatrix.dim = [600, 100] ;
	
var myfind = new JitterObject ("jit.findbounds") ;       // to find coordinates of first/last pixel.
	myfind.min = [1., 1., 1., 1.] ;
	myfind.max = [1., 1., 1., 1.] ;
	
// -------------------------------------------------------------------------------------

function anything ()
	{
		var a, txt ;
		
		a = arrayfromargs (messagename, arguments) ;
		txt = a.join (" ") ;
		
		mytext.position = myrender.screentoworld (POS_X, POS_Y) ;
		mytext.text (txt) ;
	}

function color ()
	{
		var a = arrayfromargs (arguments) ;
		
		mytext.color = a ;
		
		myfind.min = [1., a[0]-0.1, a[1]-0.1, a[2]-0.1] ;	
		myfind.max = [1., a[0]+0.1, a[1]+0.1, a[2]+0.1] ;
	}
		
function bang ()
	{
		var a ;
		
		mytextbis.text (" ") ;                 
	
		myrender.erase () ;
		myrender.drawswap () ;
		
		myfind.matrixcalc (mymatrix) ;               // to find end coordinates.
		a = myfind.boundmax ;						 
		
		mytextbis.position = myrender.screentoworld (a[0]+10, POS_Y) ;
		mytextbis.text ("is", a[0]-POS_X, "pixels long ?") ;
		
		myrender.drawswap () ;
		
		outlet (0, "jit_matrix", mymatrix.name) ;
	}
	
// -------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------:x

